	class cATTBase
//	--------------
{
	static	s_g = {};				// Global variables

	static	s_minveh = [1,5,2,2,2];		// Min vehs for route type
	static	s_cfgconn = ["rail","road","air","ship","air"];
	static	s_cfg = GetYATTSettings();

	static	s_mapsizex = AIMap.GetMapSizeX();
	static	s_mapsizey = AIMap.GetMapSizeY();
	static	s_mapdiag = (sqrt(AIMap.GetMapSizeX()*AIMap.GetMapSizeX()+
				  AIMap.GetMapSizeY()*AIMap.GetMapSizeY())).tointeger();

	static	s_dist_local_authority =
			AIGameSettings.GetValue("dist_local_authority");

	static	s_companyid = AICompany.ResolveCompanyID(AICompany.COMPANY_SELF);

//	Valid cargo id's for specific cargos

	static	s_crgpassengers	= GetCargoID(AICargo.TE_PASSENGERS);
	static	s_crgmail	= GetCargoID(AICargo.TE_MAIL);
	static	s_crggoods	= GetCargoID(AICargo.TE_GOODS);
	static	s_crgwater	= GetCargoID(AICargo.TE_WATER);
	static	s_crgfood	= GetCargoID(AICargo.TE_FOOD);

	static	s_cargo2x = GetTwoWayCargo();	// Cargo that pays both ways

//	Bank stuff

	static	s_loanint = AICompany.GetLoanInterval();

	static	DIR_I_N		= 1;		// Direction index
	static	DIR_I_NE	= 2;
	static	DIR_I_E		= 3;
	static	DIR_I_SE	= 4;
	static	DIR_I_S		= 5;
	static	DIR_I_SW	= 6;
	static	DIR_I_W		= 7;
	static	DIR_I_NW	= 8;

	static	s_offset = [null,
			    AIMap.GetTileIndex(-1,-1),AIMap.GetTileIndex(-1, 0),
			    AIMap.GetTileIndex(-1, 1),AIMap.GetTileIndex( 0, 1),
			    AIMap.GetTileIndex( 1, 1),AIMap.GetTileIndex( 1, 0),
			    AIMap.GetTileIndex( 1,-1),AIMap.GetTileIndex( 0,-1)];

	static	DIR_B_N		= 0x01;		// Direction bits
	static	DIR_B_NE	= 0x02;
	static	DIR_B_E		= 0x04;
	static	DIR_B_SE	= 0x08;
	static	DIR_B_S		= 0x10;
	static	DIR_B_SW	= 0x20;
	static	DIR_B_W		= 0x40;
	static	DIR_B_NW	= 0x80;

	static	DIR_M_SE	= 0;		// Indexes to s_map... arrays
	static	DIR_M_NW	= 1;
	static	DIR_M_SW	= 2;
	static	DIR_M_NE	= 3;
	static	DIR_M_UNKNOWN	= 4;

	static	s_mapoffs = [AIMap.GetTileIndex(0,1),AIMap.GetTileIndex(0,-1),
			     AIMap.GetTileIndex(1,0),AIMap.GetTileIndex(-1,0)];

	static	s_mapdiri = [   4,   8,   6,   2,   0];	// DIR_M to DIR_I
	static	s_mapdirb = [0x08,0x80,0x20,0x02,0x00];	// SE,NW,SW,NE,UNKNOWN

	static	s_mapdirp = [[3,2],[2,3],[0,1],[1,0]];	// Perp DIR_M L/R

	static	ATT_SLP_ERROR		= 0x00;
	static	ATT_SLP_FLAT		= 0x01;
	static	ATT_SLP_RAISED		= 0x02;
	static	ATT_SLP_FLAT_RAISED	= 0x03;
	static	ATT_SLP_SLOPED		= 0x04;
	static	ATT_SLP_SLOPED_RAISED	= 0x06;

//			tile	 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4
//					       W       N   E S
//				       S   E S S   N N W N N E
//				 F W S W E W E E N W S S E W N		   ptile
	static	s_built = [	[1,6,6,4,6,0,4,3,6,4,0,3,4,3,3],	// 0 Flat
				[1,0,6,3,6,0,4,0,6,3,3,3,4,0,0],	// 1 W
				[1,6,0,3,6,3,3,3,6,4,0,0,4,0,0],	// 2 S
				[1,6,6,3,6,3,0,3,6,0,3,3,4,3,3],	// 3 SW
				[1,6,6,4,0,0,3,0,6,4,3,0,3,0,3],	// 4 E
				[0,0,6,3,0,0,3,0,6,3,3,3,3,0,3],	// 5 EW
				[1,6,6,0,6,3,3,3,6,4,3,3,0,3,3],	// 6 SE
				[1,6,6,4,6,3,3,3,0,4,3,3,4,3,3],	// 7 WSE
				[1,6,6,4,6,3,4,0,0,3,0,0,3,3,0],	// 8 N
				[1,6,6,0,6,3,4,3,6,3,3,3,0,3,3],	// 9 NW
				[0,6,0,3,6,3,3,3,0,3,0,0,3,3,0],	// 0 NS
				[1,6,6,3,0,3,4,3,6,3,3,3,4,3,3],	// 1 NWS
				[1,6,6,4,6,3,0,3,6,0,3,3,3,3,3],	// 2 NE
				[1,6,0,4,6,3,4,3,6,3,3,3,3,3,3],	// 3 ENW
				[1,0,6,4,6,3,3,3,6,4,3,3,4,3,3]];	// 4 SEN

//			tile	 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4
//					       W       N   E S
//				       S   E S S   N N W N N E
//				 F W S W E W E E N W S S E W N		   ptile
	static	s_stpbuilt = [	[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],	// 0 Flat
				[0,0,0,4,0,0,0,3,0,4,0,3,0,3,0],	// 1 W
				[0,0,0,4,0,0,4,3,0,0,0,3,0,0,3],	// 2 S
				[0,6,6,4,0,0,0,3,0,0,0,3,0,0,0],	// 3 SW
				[0,0,0,0,0,0,4,3,0,0,0,0,4,3,3],	// 4 E
				[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],	// 5 EW
				[0,0,6,0,6,0,4,3,0,0,0,0,0,0,3],	// 6 SE
				[0,6,6,3,6,0,3,3,0,0,3,3,0,0,3],	// 7 WSE
				[0,0,0,0,0,0,0,3,0,4,0,3,4,3,3],	// 8 N
				[0,6,0,0,0,0,0,0,6,4,0,3,0,3,0],	// 9 NW
				[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],	// 0 NS
				[0,6,6,4,0,3,0,3,6,4,0,0,0,3,0],	// 1 NWS
				[0,0,0,0,6,0,0,3,6,0,0,0,4,3,3],	// 2 NE
				[0,6,0,0,6,0,0,3,6,3,3,3,4,0,3],	// 3 ENW
				[0,0,6,0,6,3,3,3,6,0,0,0,3,3,0]];	// 4 SEN

//	YATT error codes

	static	YATT_E_SUCCESS		=  1;
	static	YATT_E_INTERNAL		= -1;
	static	YATT_E_NOFUNDS		= -2;
	static	YATT_E_OTTD		= -3;		// Get last error
	static	YATT_E_NOSTOP		= -4;		// No place for stop
	static	YATT_E_RTETOOSHORT	= -5;		// Route too short
	static	YATT_E_NOPATH		= -6;		// Can't find path
	static	YATT_E_TESTBUILDFAILED	= -7;		// Test build failed
	static	YATT_E_NODEPOT		= -8;		// No place for depot
	static	YATT_E_INEFFICIENT	= -9;		// Route inefficient
	static	YATT_E_LOWPOPULATION	= -10;		// Population too small
	static	YATT_E_LOWPRODUCTION	= -11;		// Production too low
	static	YATT_E_NOVEHICLE	= -12;		// No vehicle for cargo
	static	YATT_E_RTETOOLONG	= -13;		// Route too long
	static	YATT_E_VEHLIMIT		= -14;		// Vehicle limit reached
	static	YATT_E_TOWNRATING	= -15;		// Town rating too low
	static	YATT_E_SAVING		= -16;		// Can't buys, saving
	static	YATT_E_TRAFFIC		= -17;		// Too much traffic
	static	YATT_E_ABORTED		= -18;		// Pathfinding aborted
	static	YATT_E_NOTPROFITABLE	= -19;		// Not profitable enough
	static	YATT_E_MARKEDASBAD	= -20;		// Already marked as bad
	static	YATT_E_INDCLOSING	= -21;		// Industry is closing
	static	YATT_E_FAILEDTOSTART	= -22;		// Failed to start service
	static	YATT_E_NOROUTE		= -23;		// No route found

	static	s_errstr = ["",
		"YATT internal error",				// INTERNAL
		"Not enough money",				// NOFUNDS
		"OTTD generated error",				// OTTD
		"No place for stop",				// NOSTOP
		"Route is too short",				// RTETOOSHORT
		"No path found",				// NOPATH
		"Test build failed",				// TESTBUILDFAILED
		"No place for depot",				// NODEPOT
		"Route path is inefficient",			// INEFFICIENT
		"Population is too small",			// LOWPOPULATION
		"Production is too low",			// LOWPRODUCTION
		"No vehicle found to carry cargo",		// NOVEHICLE
		"Route is too long",				// RTETOOLONG
		"Vehicle limit reached",			// VEHLIMIT
		"Town rating is too low",			// TOWNRATING
		"Cannot buy, saving for something else",	// SAVING
		"Vehicle in the way for too long",		// TRAFFIC
		"Pathfinding aborted",				// ABORTED
		"Route is not profitable enough",		// NOTPROFITABLE
		"Route is already marked as bad",		// MARKEDASBAD
		"Industry is closing",				// INDCLOSING
		"Failed to start service",			// FAILEDTOSTART
		"No route found",				// NOROUTE
		];

//	Some AIs we know of

	static	AI_YATT		= 0x00000001;		// Our twin
	static	AI_RONDJE	= 0x00000002;		// Naughty boys

//	Depot orders

	static	YATT_ORD_SELL		= 1;		// Sell vehicle
	static	YATT_ORD_UPGRADE	= 2;		// Buy new

//	Manager task codes

	static	YATT_MGR_NONE		= 0;
	static	YATT_MGR_BUYVEHICLE	= 1;
	static	YATT_MGR_SELLVEHICLE	= 2;
	static	YATT_MGR_UPGRADEVEHICLE	= 3;
	static	YATT_MGR_UPGRADEFLEET	= 4;

//	Task codes

	static	YATT_TSK_CHECKROUTE	= 1;		// P1 = route
	static	YATT_TSK_BUYVEHICLE	= 2;		// P1 = route
	static	YATT_TSK_FINDSERVICE	= 3;
	static	YATT_TSK_YEAREND	= 4;
	static	YATT_TSK_ENDRESERVE	= 5;		// P1 = route
	static	YATT_TSK_INDCLOSED	= 6;		// P1 = iid
	static	YATT_TSK_BUILDSTATUES	= 7;

//	Connection limits in days

	static	s_mindays = [ 15, 15, 10, 25, 5];
	static	s_maxdays = [ 35, 35,120, 90,30];

//	Connection distance limits for each method

	static	s_cdist = {	min = [ 50, 25, 80, 40, 25],
				max = [120, 70,250,180,180],
				abs = [  0,  0,  0,  0,  0]
			  };

//	Connection methods

	static	s_rtemethod = ["rail","road","air","ship","helicopter"];

	static	YATT_CMB_RAIL	= 0x01;
	static	YATT_CMB_ROAD	= 0x02;
	static	YATT_CMB_AIR	= 0x04;
	static	YATT_CMB_SHIP	= 0x08;
	static	YATT_CMB_HELI	= 0x10;
	static	YATT_CMB_ALL	= 0x1F;

	static	YATT_CMI_RAIL	= 0;
	static	YATT_CMI_ROAD	= 1;
	static	YATT_CMI_AIR	= 2;
	static	YATT_CMI_SHIP	= 3;
	static	YATT_CMI_HELI	= 4;
}
	function cATTBase::DebugDisable()
//	---------------------------------
//	Disable debugger, if running
{
	if(s_g.debug) s_g.dbgenabled = s_g.debug.Disable();
}
	function cATTBase::DebugEnable(silent=false)
//	--------------------------------------------
//	Enable debugger, if was running
{
	if(s_g.debug && (!silent || s_g.dbgenabled)) {
	  s_g.debug.SkipFunction("DebugEnable");	// Don't stop in here
	  s_g.debug.Enable(silent);
	}
}
	function cATTBase::Sleep(tics)
//	------------------------------
{
	if(s_g.debug) {
	  DebugDisable();

//	  local limit = AIController.GetTick() + tics;

	  AIController.UnPause();

//	  while (AIController.GetTick() < limit) {
//	    for (local i=1; i <= 100; i++) {}
//	  }

	  AIController.Sleep(tics);

	  DebugEnable(true);
	}
	else
	  AIController.Sleep(tics);
}
	function cATTBase::Info(text)
//	-----------------------------
{
	Log("Info",text);
}
	function cATTBase::Warning(text)
//	--------------------------------
{
	Log("Warning",text);
}
	function cATTBase::Error(text)
//	------------------------------
{
	Log("Error",text);
	DebugEnable();
}
	function cATTBase::GetErrorStr(errcode)
//	---------------------------------------
//	Return error string for error code
{
	return s_errstr[-errcode];
}
	function cATTBase::Log(method,text)
//	-----------------------------------
{
	local	mon = [null,"Jan","Feb","Mar","Apr","May","Jun",
			    "Jul","Aug","Sep","Oct","Nov","Dec"];
	local	date = AIDate.GetCurrentDate();
	local	day = AIDate.GetDayOfMonth(date);
	local	str = ((day < 10) ? " " : "") + day + "-" +
		      mon[AIDate.GetMonth(date)] + "-" +
		      AIDate.GetYear(date) + "  " + text;

	AILog[method](str);

	if(s_g.debug) s_g.debug.WriteLog(str);
}
	function cATTBase::AddTask(obj,funcname,task,days,p1=null,p2=null)
//	------------------------------------------------------------------
//	Add a task to be executed in the specified number of days
//	The function will be called with only one parameter, a table that
//	contains the relevant information to execute the task.
//	obj		The "this" object for the function
//	funcname	The function to call
//	task		YATT_TSK_ code
//	days		Days to wait before task is executed
//	p1,p2		Optional parameters for the function
//	Returns		Task index, can be used to remove the task
{
	local	tsk = {obj = obj, func = funcname, task = task};

	if(p1 != null) tsk.p1 <- p1;
	if(p2 != null) tsk.p2 <- p2;

	return s_g.tasks.AddTask(tsk,days);
}
	function cATTBase::RemoveTask(idx)
//	----------------------------------
//	Removes the task from the task list
//	idx		Task index returned by AddTask
{
	s_g.tasks.RemoveTask(idx);
}
	function cATTBase::SaveFunds(obj,funcname,task,funds,priority,p1=null,p2=null)
//	------------------------------------------------------------------------------
//	Add a task for which funds need to be saved
//	obj		The "this" object for the function
//	funcname	The function to call
//	task		YATT_TSK_ code
//	funds		Amount to save before function is called
//	priority	If true, added at head of queue
//	p1,p2		Optional parameters for the function
{
	local	tsk = {obj = obj, func = funcname, task = task, funds = funds,
		       p1 = p1, p2 = p2};

	if(priority && s_g.save.len())
	  s_g.save.insert(0,tsk);
	else
	  s_g.save.push(tsk);
}
	function cATTBase::GetAvailableFunds()
//	--------------------------------------
//	Return current balance + borrowable amount
//	Keeps MaxLoanAmount / 40 in reserve
{
	return AICompany.GetBankBalance(AICompany.COMPANY_SELF) -
	       AICompany.GetMaxLoanAmount() / 40 +
	       (AICompany.GetMaxLoanAmount() - AICompany.GetLoanAmount());
}
	function cATTBase::GetFunds(funds)
//	----------------------------------
//	Make sure we have sufficient funds for a project
//	Returns		true if we have enough money
{
	local	balance = AICompany.GetBankBalance(AICompany.COMPANY_SELF);
	local	loan = AICompany.GetLoanAmount();
	local	maxloan = AICompany.GetMaxLoanAmount();

	if(balance > funds * 2) return true;

	local	needed = funds - balance;

	if(maxloan - maxloan/40 - loan < needed) return false;
			  
	return AICompany.SetMinimumLoanAmount(maxloan);
}
	function cATTBase::GetMaxLoan()
//	-------------------------------
{
	local	maxloan = AICompany.GetMaxLoanAmount();

	return AICompany.SetMinimumLoanAmount(maxloan);
}
	function cATTBase::WaitForFunds()
//	---------------------------------
{
	Sleep(20);
	GetMaxLoan();
}
	function cATTBase::GetNewRouteFunds(funds)
//	------------------------------------------
//	Funds for new routes leave the reserve fund available
{
	return GetFunds(funds + s_g.ressum);
}
	function cATTBase::RepayLoan()
//	------------------------------
{
	local	loan = AICompany.GetLoanAmount();

	if(loan) {
	  local	balance = AICompany.GetBankBalance(AICompany.COMPANY_SELF);

	  if(balance > s_loanint) {
	    if(balance >= loan)
	      AICompany.SetLoanAmount(0);
	    else
	      AICompany.SetLoanAmount(loan - s_loanint * (balance / s_loanint));
	  }
	}
}
	function cATTBase::IsSaving()
//	-----------------------------
//	Returns		true if saving for something
{
	return (s_g.save.len() != 0);
}
	function cATTBase::AddReserve(t)
//	--------------------------------
//	Add table to list of reserved funds, sum reserved funds
//	t	Table with at least the following fields
//		route		route the funds are reserved for
//		funds		funds reserved
{
	foreach (i,v in s_g.restab) {
	  if(v.route == t.route) {
	    s_g.ressum = s_g.ressum - v.funds + t.funds;
	    s_g.restab[i] = t;
	    return;
	  }
	}

	s_g.restab.push(t);
	s_g.ressum += t.funds;
}
	function cATTBase::RemoveReserve(route)
//	---------------------------------------
//	Find reservation table for route, return it or null if not found
//	If found remove it from array
{
	foreach (i,v in s_g.restab) {
	  if(v.route == route) {
	    s_g.ressum -= v.funds;
	    local t = v;
	    s_g.restab.remove(i);
	    return t;
	  }
	}

	return null;
}
