	class YATT extends AIInfo 
{
	function GetVersion()     	{ return 1; }
	function GetDate()		{ return "2010-05-26"; }
	function MinVersionToLoad()	{ return 1; }
	function GetAPIVersion()	{ return "1.0"; }

	function GetName()		{ return "YATT"; }
	function GetDescription()	{ return "Yet Another Transport Tycoon"; }
	function CreateInstance()	{ return "YATT"; }
	function GetShortName()		{ return "YATT"; }
	function GetAuthor()		{ return "Attila"; }
   
	function GetSettings() 
//	----------------------
  {
	local	desc = ["trains","road vehicles","planes","ships"];

	foreach (i,v in ["rail","road","air","ship"]) {
	  AddSetting({	name = v,
			description = "Allow building of " + desc[i],
			easy_value = 1,
			medium_value = 1,
			hard_value = 1,
			custom_value = 1,
			flags = AICONFIG_BOOLEAN + AICONFIG_INGAME
			});
	}

	AddSetting({	name = "subsidies",
			description = "Allow subsidized routes",
			easy_value = 1,
			medium_value = 1,
			hard_value = 1,
			custom_value = 1,
			flags = AICONFIG_BOOLEAN
			});

	AddSetting({	name = "pax",
			description = "Allow pax cargo",
			easy_value = 1,
			medium_value = 1,
			hard_value = 1,
			custom_value = 1,
			flags = AICONFIG_BOOLEAN
			});

	AddSetting({	name = "freight",
			description = "Allow freight cargo",
			easy_value = 1,
			medium_value = 1,
			hard_value = 1,
			custom_value = 1,
			flags = AICONFIG_BOOLEAN
			});

	AddSetting({	name = "efficiency",
			description = "Max efficiency",
			min_value = 0,
			max_value = 100,
			easy_value = 60,
			medium_value = 80,
			hard_value = 100,
			custom_value = 100,
			step_size = 10,
			flags = 0
			});

	AddSetting({	name = "looptime",
			description = "Processing speed",
			min_value = 1,
			max_value = 5,
			easy_value = 5,
			medium_value = 3,
			hard_value = 1,
			custom_value = 1,
			flags = 0
			});

	AddLabels("looptime", {_1 = "Normal", _2 = "Sligthly slow",
				_3 = "More slow", _4 = "Very slow",
				_5 = "Slowest"});
  }
}
 
	RegisterAI(YATT());
