	class cATTStation extends cATTBase
//	----------------------------------
{
	static	YATT_STN_TRAIN	= 1;
	static	YATT_STN_TRUCK	= 2;
	static	YATT_STN_BUS	= 3;
	static	YATT_STN_AIR	= 4;
	static	YATT_STN_DOCK	= 5;

	c_id = null;				// AI station id
	c_yid = null;				// YATT id
	c_type = null;				// AIStation type
	c_tile = null;				// Location
	c_routes = null;			// Routes using  station
	c_built = null;				// Station built
	c_refcnt = null;			// Usage reference count

	constructor(type)
//	-----------------
	{
	  c_type = type;
	  c_tile = null;
	  c_routes = [];
	  c_built = false;
	  c_refcnt = 0;
	}
}
	function cATTStation::SetStationInfo(tile)
//	------------------------------------------
{
	c_tile = tile;
	c_id = AIStation.GetStationID(tile);
	c_yid = "S" + c_id.tostring();
}
	function cATTStation::GetCargoWaiting(cargo)
//	--------------------------------------------
{
	return AIStation.GetCargoWaiting(c_id,cargo);
}
	function cATTStation::GetCargoRating(cargo)
//	-------------------------------------------
{
	return AIStation.GetCargoRating(c_id,cargo);
}
